/*(c) Jippy Snake (7/8) Entwicklungsteam.
 *
 *
 *Dieser Code wird unter der GNU Public Licence vertireben
 *
 *
 */

import java.util.Iterator;
import java.util.LinkedList;

class Coord {
	private int posX;
	private int posY;
	private int posZ;
	
	public Coord(int pX, int pY) {
		posX = pX;
		posY = pY;
		posZ = 0;
	}
	
	public Coord(int pX, int pY, int pZ) {
		posX = pX;
		posY = pY;
		posZ = pZ;
	}
	
	public void setPos(int pX, int pY) {
		posX = pX;
		posY = pY;
		posZ = 0;
	}
	
	public void setPos(int pX, int pY, int pZ) {
		posX = pX;
		posY = pY;
		posZ = pZ;
	}
	
	public int getX() {
		return posX;
	}
	
	public int getY() {
		return posY;
	}
	
	public int getZ() {
		return posZ;
	}
	
	public boolean equals(Coord cmp) {
		if (cmp == null) return false;
		boolean ret = (posX == cmp.getX()) && (posY == cmp.getY()) && (posZ == cmp.getZ());
		return ret;
	}
	
	public boolean equals(Coord cmp, String comp) {
		boolean cmpX, cmpY, cmpZ;
		if (cmp == null) return false;
		if (comp.contains("x"))
			cmpX = (posX == cmp.getX());
		else cmpX = true;
		
		if (comp.contains("y"))
			cmpY = (posY == cmp.getY());
		else cmpY = true;
		
		if (comp.contains("z"))
			cmpZ = (posZ == cmp.getZ());
		else cmpZ = true;
		return cmpX && cmpY && cmpZ;
	}
	
	public String toString() {
		return "("+posX+" "+posY+" "+posZ+")";
	}
	
	public Coord getLeft() {
		return new Coord(posX-1, posY);
	}
	public Coord getRight() {
		return new Coord(posX+1, posY);
	}
	public Coord getUp() {
		return new Coord(posX, posY-1);
	}
	public Coord getDown() {
		return new Coord(posX, posY+1);
	}
	public Coord getHigh() {
		return new Coord(posX, posY, posZ+1);
	}
	public Coord getLow() {
		return new Coord(posX, posY, posZ-1);
	}
	
	public Coord add(Coord toAdd) {
		return new Coord(posX+toAdd.getX(), posY+toAdd.getY(), posZ+toAdd.getZ());
	}
	
	public Coord sub(Coord toSub) {
		return new Coord(posX-toSub.getX(), posY-toSub.getY(), posZ-toSub.getZ());
	}
	
	public boolean isLeftOf(Coord c) {
		return posX < c.posX;
	}
	public boolean isRightOf(Coord c) {
		return posX > c.posX;
	}
	public boolean isUpOf(Coord c) {
		return posY < c.posY;
	}
	public boolean isDownOf(Coord c) {
		return posY > c.posY;
	}
	
	public int scaleProd(Coord c) {
		return posX*c.getX()+posY*c.getY()+posZ*c.getZ();
	}
	
	public Coord scaleMult(int s) {
		return new Coord(posX*s, posY*s, posZ*s);
	}
	public static Coord getZeroCoord() {
		return new Coord(0,0,0);
	}
	
	public static Coord randCoord(Coord min, Coord max) {
		return new Coord((int) (Math.random()*(max.getX()-min.getX()))+min.getX(),
		                   (int) (Math.random()*(max.getY()-min.getY()))+min.getY(),
		                   (int) (Math.random()*(max.getZ()-min.getZ()))+min.getZ());
	}
	
	public Coord clone() {
		return new Coord(posX, posY, posZ);
	}
	
	public static LinkedList<Coord> range(Coord a, Coord b) {
		//a.X <= b.X and a.y <= b.y!!!
		LinkedList<Coord> ll = new LinkedList<Coord>();
		
		for (int z = a.getZ(); z <= b.getZ(); z++)
			for (int y = a.getY(); y <= b.getY(); y++)
				for (int x = a.getX(); x <= b.getX(); x++)
					ll.add(new Coord(x,y,z));
		
		return ll;
	}
}