/**
  * A small implementation of a binary tree that saves Stings.
  * Licence: GPLv2
**/

class FuncTree {
	private String func = "";
	private String name = "";
	protected FuncTree left = null;
	protected FuncTree right = null;
	protected FuncTree root;
	
	/**
	  * Creates a functiontree with r als root
	  * @param r The root Functiontree
	  * @param left inicates, if this tree is the left subtree of r.
	  *             if left is true r.left will be this
	  *             Otherwise r.right will be this
	**/
	public FuncTree(FuncTree r, boolean left, String name) {
		this.name = name;
		setRoot(r, left);
	}
	
	/**
	  * Sets the functioname of this Functiontree
	  * @param func The functionname to set
	**/
	public void setFunc(String func) {
		this.func = func;
	}
	
	/**
	  * @return the functionname of this functiontree
	**/
	public String getFunc() {
		return func;
	}
	
	/**
	  * @return the name of this functiontree
	**/
	public String getName() {
		return name;
	}
	
	/**
	  * @return Left subtree
	**/
	public FuncTree left() {
		return left;
	}
	
	/**
	  * @return Right subtree
	**/
	public FuncTree right() {
		return right;
	}
	
	/**
	  * @return Root tree
	**/
	public FuncTree root() {
		return root;
	}
	
	/**
	  * Sets the root of this Functiontree to r
	  * @param r the new Roottree
	  * @param left inicates, if this tree is the left subtree of r.
	  *             if left is true r.left will be this
	  *             Otherwise r.right will be this
	**/
	public void setRoot(FuncTree r, boolean left) {
		this.root = r;
		if (root != null) {
			if (left) root.left = this;
			else root.right = this;
		}
	}
	
	/**
	  * Prints the Functiontree to standart-output
	**/
	public void print(int level) {
		if (right != null) right.print(level+1);
		for (int i = 0; i < level; i++) System.out.print("\t");
		System.out.println(func);
		if (left != null) left.print(level+1);
	}
} 
