/*

	(c) Shopping-ManaJer develoment-team
	This Code is published unter the Gnu-GPL v2
	
	Modified for JippySnake7
	Modified for Jippy Snake 8
*/

import java.awt.Canvas;
import java.awt.Color;
import javax.swing.JLabel;

class GUIUpdater {
	private Renderer rend;
	private JS8Level l;
	private Snake s;
	private Language lang;
	
	private Player p;
	private boolean drawPaused;
	
	//Need to know where to draw new green apples
	private int appleNr;
	private int drawApplesX;
	private int drawApplesY;
	private int curApples;
	
	int size = 64;
	int off = -1*size/4;
	int fak = size/8;
	
	public GUIUpdater(Canvas c, Player p) {
		this.p = p;
		drawPaused = false;
		rend = new Renderer(c, "graphics/graphics.xml", p.getLanguage());
		lang = new Language(p.getLanguage());
		rend.drawRect(0, Color.BLACK, 0,0, 1920, 1080);
	}
	
	public void setLevel(JS8Level lv) {
		l = lv;
		prepareHud();
	}
	
	public synchronized void prepareHud() {
		//code for preparing hud here
		//makr hud black
		rend.drawRect(12,Color.BLACK, 25*size,0, 5*size,16*size);
		curApples = 0;
		
		//draw toDo Apples
		drawApplesX = 0;
		drawApplesY = 0;
		appleNr = 1;
		for (int i = 0; i < l.getMinApples(); i++) {
			rend.drawImage(12, 1210+appleNr, 25*size+drawApplesX*4*fak, drawApplesY*4*fak);
			incPos();
		}
		
		//draw record-apples
		drawApplesX = 0;
		drawApplesY = 0;
		appleNr = 1;
		for (int i = 0; i < p.getLevelRecord(l.getName()); i++) {
			rend.drawImage(12, 1230+appleNr, 25*size+drawApplesX*4*fak, drawApplesY*4*fak);
			incPos();
		}
		drawApplesX = 0;
		drawApplesY = 0;
		appleNr = 1;
	}
	
	public void setSnake(Snake snk) {
		s = snk;
	}
	
	public synchronized void draw(boolean paused) {
		if (s == null) return;
		if (paused && drawPaused) {
			rend.flushScreen();
			return;
		}
		if (!paused && drawPaused) drawPaused = false;
		
		//Begin new Hud code
		//if snake hs eaten an apple, draw it on hud
		if (s.getLength() > curApples) {
			curApples++;
			rend.drawImage(12, 1220+appleNr, 25*size+drawApplesX*4*fak, drawApplesY*4*fak);
			incPos();
		}
		
		//renew all snake-layers and draw snake and apples
		for (int i = 0; i < 5; i++)
			rend.reNewLayer(2*i+1);
		drawSnake();
		
		//prerender
		preRender(s.getHeadPos().getZ());
		
		//draw timebar
		drawTimeBarAndBlind();
		//if game was paused, save that pausdrawing has been done
		if (paused) {
			drawPaused = true;
			//drawMenu();
		}
		
		//flush picture on screen
		showGame();
		long end = System.nanoTime();
	}
	
	//draws the level
	public synchronized void drawLevel() {
		if (l == null) return;
		int X;
		int Y;
		int Z;
		
		rend.reNewAllLayers();
		for (Coord crd : Coord.range(new Coord(0,0,-1), new Coord(24,15,4))) {
			X = crd.getX();
			Y = crd.getY();
			Z = crd.getZ()+1;
			if (l.getTile(crd, true) != 1)
				rend.drawImage(Z*2, l.getTile(crd, true), size*X, size*Y);
		}
		rend.drawRect(0, Color.BLACK, 0, 16*size, 30*size, 7*fak);
		prepareHud();
	}
	
	private synchronized void drawSnake() {
		if (s == null) return;
		if (l == null) return;
		int X;
		int Y;
		int Z;
		for (Coord crd : Coord.range(Coord.getZeroCoord(), new Coord(24,15,4))) {
			X = crd.getX();
			Y = crd.getY();
			Z = crd.getZ();
			if (l.isAppleAt(crd)) rend.drawImage(2*Z+1, 1210, size*X, size*Y);
		}
		
		X = s.getHeadPos().getX();
		Y = s.getHeadPos().getY();
		Z = s.getHeadPos().getZ();
		rend.drawImage(2*Z+1, s.getHeadTexture(), size*X, size*Y);
		
		for (SnakeElement e: s.getBodyElements()) {
			X = e.getPos().getX();
			Y = e.getPos().getY();
			Z = e.getPos().getZ();
			rend.drawImage(2*Z+1, e.getTexture(), size*X, size*Y);
		}
		
	}
	
	private synchronized void drawTimeBarAndBlind() {
		if (l == null) return;
		if (s == null) return;
		
		//Draw blindess, if needed
		if (l.isBlind()) {
			Coord h = s.getHeadPos();
			//Determ the points of the blind-rect
			int sx = 64*(h.getX()-4);
			int sy = 64*(h.getY()-4);
			int ex = sx+576;
			int ey = sy+576;
			
			//draw blind-rect
			rend.drawImageOnScreen(1201, sx, sy);
			
			//Make the rest dark
			rend.drawRectOnScreen(Color.BLACK, 0,0, 1600, sy+1); //Top of blind-rect
			rend.drawRectOnScreen(Color.BLACK, 0,ey-1, 1600, 1026-ey); //down of blind-rect
			rend.drawRectOnScreen(Color.BLACK, 0,sy, sx+1, 576); //Left of blind-rect
			rend.drawRectOnScreen(Color.BLACK, ex-1,sy, 1602-ex, 576); //Right of blind-rect
		}
		
		rend.drawRectOnScreen(Color.BLACK, 0,1024, 1920,56);
		if (l.getLevelTime() >= 0) {
			//get the width of the timerbar
			int barWidth = (int) (1920*((1.0*l.getTime())/(1.0*l.getLevelTime())));
			//get color of tmerbar
			int r = 0;
			int g = 0;
			if (barWidth <= 960) {
				g = (int) ((255.0*barWidth)/960);
				r = 255;
			} else {
				g = 255;
				r = (int) ((255*(-1.0*barWidth+1920))/960);
			}
			rend.drawRectOnScreen(new Color(r,g,0), 0,1024, barWidth,56);
		}
		rend.renderExtraLayer();
	}
	
	private synchronized void drawText(String text, int px, int py) {
		int line = 0;
		int col = 0;
		for (int i = 0; i < text.length(); i++) {
			char c = text.charAt(i);
			if (c == '\n') {
				line++;
				col = 0;
				continue;
			}
			rend.drawSubImageOnScreen(1200, Globals.charMap.get(""+c), px+17*col, py+32*line);
			col++;
		}
	}
	
	public synchronized void drawIntroText(String text) {
		String introText = text.replaceAll("%MENU", lang.translate(p.getKey("menu")));
		preRender(s.getHeadPos().getZ());
		drawTimeBarAndBlind();
		rend.drawRectOnScreen(new Color(0,0,0,128), 0,0, 1920,1080);
		drawText(introText, 128,128);
		showGame();
	}
	
	public synchronized void drawMenu(int menu, int menuPage, int selectedLevel) {
		preRender(s.getHeadPos().getZ());
		drawTimeBarAndBlind();
		
		//Draw base
		rend.drawImageOnScreen(1100,    0,0);
		if (menu > 0) {
			//Draw menu-up button
			rend.drawImageOnScreen(1101, 1664,64);
		} else {
			//Draw exit button
			rend.drawImageOnScreen(1102, 1664,768);
		}
		
		if (menu == 0) { //Main menu
			rend.drawImageOnScreen(1105,  576,128);
			rend.drawImageOnScreen(1107,  576,576);
			rend.drawImageOnScreen(1106, 1056,128);
			rend.drawImageOnScreen(1108, 1056,578);
		} else if (menu > 0) { //Level-choose menu
			//get the numbers of levels to show
			int maxLevel = 0;
			if (menu == 1) {
				maxLevel = p.getCampaignLevel();
				if (p.getCampaignDone()) maxLevel = 150;
			} else if (menu == 2) {
				maxLevel = Globals.ownLevels.size(); //p.getCampaignLevel();
			} else if (menu == 3) {
				maxLevel = Globals.extraLevels.size(); //p.getCampaignLevel();
			}
			
			//draw menu-title
			rend.drawImageOnScreen(1110+menu, 576, 0);
			
			//Draw levels
			int drawXpos = 0;
			int drawYpos = 0;
			for (int i = 18*menuPage; i < Math.min(maxLevel, 18*menuPage+18); i++) {
				String lName = "";
				rend.drawImageOnScreen(1109, 576+448*drawXpos, 128+64*drawYpos);
				if (menu == 1)
					lName = Globals.campaignLevels.elementAt(i).getName();
				if (menu == 2)
					lName = Globals.ownLevels.elementAt(i).getName();
				if (menu == 3)
					lName = Globals.extraLevels.elementAt(i).getName();
				
				if (lName.length() > 20) lName = lName.substring(0,17)+"...";
				drawText(lName, 592+448*drawXpos, 144+64*drawYpos);
				
				drawXpos++;
				if (drawXpos > 1) {
					drawXpos = 0;
					drawYpos++;
				}
			}
			
			//Draw page-changer
			if (menuPage > 0) rend.drawImageOnScreen(1103, 448, 448);
			if (menuPage < ((int) Math.ceil(maxLevel/18.0))-1) rend.drawImageOnScreen(1104, 1472, 448);
			
			//draw infos of selectedLevel
			if (selectedLevel >= 0) {
				LevelInfo li;
				if (menu == 1) {
					li = Globals.campaignLevels.elementAt(selectedLevel);
				} else if (menu == 2) {
					li = Globals.ownLevels.elementAt(selectedLevel);
				} else {
					li = Globals.extraLevels.elementAt(selectedLevel);
				}
				rend.drawImageOnScreen(1110, 752, 736);
				String lName = li.getName();
				String lAuthor = li.getAuthor();
				if (lName.equals("")) lName = "NONAME";
				if (lAuthor.equals("")) lAuthor = "UNKNOWN";
				if (lName.length() > 28) lName = lName.substring(0,25)+"...";
				if (lAuthor.length() > 27) lAuthor = lAuthor.substring(0,24)+"...";

				drawText(lang.translate("NAME")+": "+lang.translate(lName), 768, 752);
				drawText(lang.translate("AUTHOR")+": "+lang.translate(lAuthor), 768, 784);
				int r = p.getLevelRecord(li.getName());
				if (r < 0) drawText(lang.translate("NEVERPLAYED"), 768, 816);
				else drawText(lang.translate("RECORD")+": "+p.getLevelRecord(li.getName()), 768, 816);
				if (r >= 0) {
					if (p.getLevelFilled(li.getName())) drawText(lang.translate("FILLED")+": "+lang.translate("YES"), 768, 848);
					else drawText(lang.translate("FILLED")+": "+lang.translate("NO"), 768, 848);
				}
			}
		}
		showGame();
	}
	
	private void preRender(int offset) {
		rend.drawRectOnScreen(Color.BLACK, 0,0, 1920,1080);
		rend.preRenderLayer( 0, -0+offset*16); //BG-Layer
		rend.preRenderLayer( 1, -0+offset*16); //Snake-Layer 0
		rend.preRenderLayer( 2,-16+offset*16); //Level-Layer 0
		rend.preRenderLayer( 3,-16+offset*16); //Snake-Layer 1
		rend.preRenderLayer( 4,-32+offset*16); //Level-Layer 1
		rend.preRenderLayer( 5,-32+offset*16); //Snake-Layer 2
		rend.preRenderLayer( 6,-48+offset*16); //Level-Layer 2
		rend.preRenderLayer( 7,-48+offset*16); //Snake-Layer 3
		rend.preRenderLayer( 8,-64+offset*16); //Level-Layer 3
		rend.preRenderLayer( 9,-64+offset*16); //Snake-Layer 4
		rend.preRenderLayer(10,-80+offset*16); //Level-Layer 4
		rend.preRenderLayer(11,-80+offset*16); //FG-Layer
	}
	
	public synchronized void showGame() {
		rend.flushScreen();
	}
	
	private synchronized void incPos() {
		appleNr++;
		if (appleNr == 8) {
			appleNr = 1;
			drawApplesX++;
		}
		if (drawApplesX == 10) {
			drawApplesX = 0;
			drawApplesY++;
		}
	}
}