/*(c) Jippy Snake 8 Developmentteam.
 *
 *
 * This code is published unter GNU Public Licence v2.
 *
 *
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Timer;

class GameWindow extends JFrame {
	private Canvas cGame = new Canvas() {
		public void paint(Graphics g) {
			drawScreen();
		}
	};
	
	private Timer t;
	
	private Snake s;
	private GUIUpdater g;
	private GameLoop gl;
	private Player p;
	
	private int sx;
	private int sy;
	private int xres;
	private int yres;
	
	private Canvas cDummy1;
	private Canvas cDummy2;
	private Canvas cDummy3;
	private Canvas cDummy4;
	
	private int curMenu;
	private int curMenuPage;
	private int curMenuMaxPage;
	private int selectedLevel;
	private boolean levelLoaded;
	
	public GameWindow(Player p) {
		curMenu = 0;
		curMenuPage = 0;
		curMenuMaxPage = 0;
		levelLoaded = false;
		
		Dimension d = getToolkit().getScreenSize();
		sx = (int) d.getWidth();
		sy = (int) d.getHeight();
		
		this.p = p;
		
		xres = p.getScreenRes();
		//if (xres > sx) xres = sx;
		yres = (9*xres)/16;
		
		cGame.setSize(xres, yres);
		cGame.setBackground(new Color(0,0,0));
		s = new Snake(new Coord(1,1,0));
		s.setHeadTexture(1000);
		setLayout(new BorderLayout());
		
		if (p.getFullscreen()) {
			cDummy1 = new Canvas();
			cDummy2 = new Canvas();
			cDummy3 = new Canvas();
			cDummy4 = new Canvas();
			cDummy1.setBackground(Color.BLACK);
			cDummy2.setBackground(Color.BLACK);
			cDummy3.setBackground(Color.BLACK);
			cDummy4.setBackground(Color.BLACK);
			cDummy1.setSize(sx, (sy-yres)/2);
			cDummy2.setSize(sx, (sy-yres)/2);
			cDummy3.setSize((sx-xres)/2, yres);
			cDummy4.setSize((sx-xres)/2, yres);
			add(cDummy1, BorderLayout.SOUTH);
			add(cDummy2, BorderLayout.NORTH);
			add(cDummy3, BorderLayout.WEST);
			add(cDummy4, BorderLayout.EAST);
			setUndecorated(true);
			setAlwaysOnTop(true);
		}
		add(cGame, BorderLayout.CENTER);
		
		pack();
		if (p.getFullscreen()) {
			setSize(sx,sy);
		}
		
		setResizable(false);
		setTitle("Jippy Snake 8");
		setVisible(true);
		g = new GUIUpdater(cGame, p);
		
		cGame.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				if (e.getKeyCode() == getKey("up"))
					turn(0,-1);
				else if (e.getKeyCode() == getKey("down"))
					turn(0,1);
				else if (e.getKeyCode() == getKey("left"))
					turn(-1,0);
				else if (e.getKeyCode() == getKey("right"))
					turn(1,0);
				else if (e.getKeyCode() == getKey("menu"))
					pause();
			}
		});
		
		cGame.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				click(e.getX(), e.getY());
			}
		});
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				exit();
			}
		});
		
		gl = new GameLoop(g, p);
		t = new Timer();
		t.schedule(gl,0,250);
		cGame.requestFocus();
		g.drawMenu(curMenu, curMenuPage, selectedLevel);
	}
	
	private void click(int x, int y) {
		if (!Globals.menuOpen) return;
		int px = (int) (1.0*x*1920.0/xres);
		int py = (int) (1.0*y*1080.0/yres);
		
		if (curMenu == 0) {
			//Exit Button
			if ((px >= 1664) && (px < 1856) && (py >= 768) && (py < 960)) {
				exit();
			}
		} else {
			//Menu up button
			if ((px >= 1664) && (px < 1856) && (py >= 64) && (py < 256)) {
				curMenu = 0;
				curMenuPage = 0;
				selectedLevel = -1;
			}
		}
		//On a levelchoose menu
		if (curMenu > 0) {
			//Menu page buttons
			if ((px >= 448) && (px < 512) && (py >= 448) && (py < 576)) {
				if (curMenuPage > 0) {
					curMenuPage--;
				}
			}
			if ((px >= 1472) && (px < 1536) && (py >= 448) && (py < 576)) {
				if (curMenuPage < curMenuMaxPage) {
					curMenuPage++;
				}
			}
			
			//Left lvelColumn
			if ((px >= 576) && (px < 960) && (py >= 128) && (py < 704)) {
				selectedLevel = curMenuPage*18+2*(((int) (py/64))-2);
			}
			//Right lvelColumn
			if ((px >= 1024) && (px < 1408) && (py >= 128) && (py < 704)) {
				selectedLevel = curMenuPage*18+2*(((int) (py/64))-2)+1;
			}
			if ((curMenu == 1) && (selectedLevel >= Globals.campaignLevels.size())) selectedLevel = -1;
			if ((curMenu == 2) && (selectedLevel >= Globals.ownLevels.size())) selectedLevel = -1;
			if ((curMenu == 3) && (selectedLevel >= Globals.extraLevels.size())) selectedLevel = -1;
			
			//Levelinfo button
			if ((px >= 752) && (px < 1296) && (py >= 736) && (py < 896)) {
				if (selectedLevel >= 0) {
					JS8Level l;
					if (curMenu == 1) l = new JS8Level(Globals.campaignLevels.elementAt(selectedLevel).getFile());
					else if (curMenu == 2) l = new JS8Level(Globals.ownLevels.elementAt(selectedLevel).getFile());
					else l = new JS8Level(Globals.extraLevels.elementAt(selectedLevel).getFile());
					gl.setCampaignMode(false);
					if (loadLevel(l)) {
						return;
					}
					Globals.menuOpen = false;
				}
			}
		}
		
		//On main Menu
		if (curMenu == 0) {
			//Play button
			if ((px >= 576) && (px < 928) && (py >= 128) &&(py < 448)) {
				gl.setCampaignMode(true);
				JS8Level l = new JS8Level(Globals.campaignLevels.elementAt(p.getCampaignLevel()).getFile());
				if (loadLevel(l)) {
					return;
				}
				Globals.menuOpen = false;
			}
			
			//Replay-levels button
			if ((px >= 1056) && (px < 1408) && (py >= 128) &&(py < 448)) {
				curMenu = 1;
				selectedLevel = -1;
				if (p.getCampaignLevel() == 0) curMenuMaxPage = 0;
				else curMenuMaxPage = (int) Math.ceil(Math.min(p.getCampaignLevel(), 150)/18.0)-1;
				if (p.getCampaignDone()) curMenuMaxPage = 8;
				//else curMenuMaxPage = (int) Math.ceil(Globals.campaignLevels.size()/18.0)-1;
			}
			
			//Own-levels button
			if ((px >= 576) && (px < 928) && (py >= 576) &&(py < 896)) {
				curMenu = 2;
				selectedLevel = -1;
				curMenuMaxPage = (int) Math.ceil(Globals.ownLevels.size()/18.0)-1;
			}
			
			//Extra-levels button
			if ((px >= 1056) && (px < 1408) && (py >= 576) &&(py < 896)) {
				curMenu = 3;
				selectedLevel = -1;
				curMenuMaxPage = (int) Math.ceil(Globals.extraLevels.size()/18.0)-1;
			}
		}
		if (Globals.menuOpen) g.drawMenu(curMenu, curMenuPage, selectedLevel);
	}
	
	//load a JS8Level
	//return: true, if intro text is shows, false otherwise
	private boolean loadLevel(JS8Level l) {
		if (!gl.setLevel(l)) return true;
		levelLoaded = true;
		if (!l.getIntroText().equals("NULL")) {
			String introText = Globals.getIntroText(l.getIntroText());
			if (!introText.equals("NULL")) {
				gl.pause();
				g.drawIntroText(introText);
				return true;
			}
		}
		return false;
	}
	
	private int getKey(String key) {
		if (p == null) return 0;
		Integer k = Globals.keyCodes.get(p.getKey(key));
		if (k == null) return 0;
		return k;
	}
	
	private void drawScreen() {
		if (g != null) {
			g.showGame();
		}
	}
	
	private void turn(int x, int y) {
		gl.setDir(new Coord(x,y));
	}
	
	private void pause() {
		if (!levelLoaded) return;
		gl.pause();
		if (Globals.menuOpen) g.drawMenu(curMenu, curMenuPage, selectedLevel);
	}
	
	private void exit() {
		gl.savePlayer();
		System.exit(0);
	}
} 
