/*(c) Jippy Snake 7/8 Developmentteam.
 *
 *
 * This code is published unter GNU Public Licence v2.
 *
 *
 */

//Modified for JS8
import java.awt.Rectangle;
import java.awt.event.KeyEvent;
import java.util.HashMap;
import java.util.Vector;
import java.io.*;
import javax.swing.filechooser.*;
import java.util.Arrays;

import org.xml.sax.*;
import org.w3c.dom.*;
import javax.xml.parsers.*;

 class Globals {
	static int SIZE_X;
	static int SIZE_Y;
	
	static String GAMEROOT;
	static String HOMEGAMEFOLDER;
	static String OWNLEVELFOLDER;
	static HashMap<String, Rectangle> charMap;
	static HashMap<String, Integer> keyCodes;
	static Vector<LevelInfo> campaignLevels;
	static Vector<LevelInfo> ownLevels;
	static Vector<LevelInfo> extraLevels;
	
	static boolean menuOpen;
	static boolean firstStart;
	
	private static NodeList texts;
	
	public static Player init() {
		//Begin game with main menu
		menuOpen = true;
		firstStart = false;
		//set fieldsizes
		SIZE_X = 25;
		SIZE_Y = 16;
		
		//get directory of game
		getGameRoot();
		
		//set revelant path
		FileSystemView fsw = FileSystemView.getFileSystemView();
		File hf = fsw.getDefaultDirectory();
		HOMEGAMEFOLDER = hf.getAbsolutePath()+"/.jippysnake8/";
		OWNLEVELFOLDER = hf.getAbsolutePath()+"/.jippysnake8/ownLevels/";
		
		//check if directorys exits, and create them, if needed
		if (!(new File(HOMEGAMEFOLDER).exists())) new File(HOMEGAMEFOLDER).mkdir();
		if (!(new File(OWNLEVELFOLDER).exists())) new File(OWNLEVELFOLDER).mkdir();
		
		//check for player-savegame file, create it, if needed
		try {
			File filePlayer = new File(HOMEGAMEFOLDER+"savegame.xml");
			//If playerfile does not exist, copy da default one
			if (!filePlayer.exists()) {
				FileReader defaultSGReader = new FileReader(GAMEROOT+"dSg.xml");
				FileWriter playerSGWriter  = new FileWriter(filePlayer);
				while (defaultSGReader.ready()) {
					playerSGWriter.write(defaultSGReader.read());
				}
				defaultSGReader.close();
				playerSGWriter.flush();
				playerSGWriter.close();
				firstStart = true;
			}
		} catch (Exception e) {
			System.out.println("Globals: ");
			e.printStackTrace();
		}
		
		//Fill hashmap that contains the rectangels for the chars in the font-image
		charMap = new HashMap<String, Rectangle>();
		keyCodes = new HashMap<String, Integer>();
		fillCharMap();
		fillKeyCodes();
		
		//fetch all Levels, ans sort them
		campaignLevels = new Vector<LevelInfo>();
		ownLevels = new Vector<LevelInfo>();
		extraLevels = new Vector<LevelInfo>();
		getLevels(GAMEROOT+"levels/", campaignLevels);
		getLevels(GAMEROOT+"extraLevels/", extraLevels);
		getLevels(OWNLEVELFOLDER, ownLevels);
		sort(campaignLevels);
		sort(ownLevels);
		sort(extraLevels);
		
		Player p = new Player(HOMEGAMEFOLDER+"savegame.xml");
		
		//create dom-access to level-texts
		try {
			Document doc = DocumentBuilderFactory.newInstance().newDocumentBuilder().parse(new File(GAMEROOT+"language/levelTexts_"+p.getLanguage()+".xml"));
			texts = doc.getElementsByTagName("text");
		} catch( Throwable t ) {
			t.printStackTrace();
		}
		
		//Create and return Player
		return p;
	}
	
	public static String getIntroText(String text) {
		Node textNode = null;
		for (int i = 0; i < texts.getLength(); i++) {
			//Check if node is the nneded one
			Node n = texts.item(i);
			if (n.getNodeType() == Node.ELEMENT_NODE) {
				Element e = (Element) n;
				if (e.getAttribute("name").equals(text)) {
					textNode = n;
					break;
				}
			}
		}
		//if nde was not found, return NULL string
		if (textNode == null) return "NULL";
		
		//Get test from Node
		Node txt = textNode.getFirstChild();
		if (txt.getNodeType() != Node.TEXT_NODE) return "NULL";
		String ret = ((Text) txt).getWholeText();
		return ret.replaceAll("%br", "\n");
	}
	
	private static void sort(Vector<LevelInfo> target) {
		if (target.size() < 2) return;
		LIComparator lic = new LIComparator();
		LevelInfo[] lia = new LevelInfo[target.size()];
		
		for (int i = 0; i < lia.length; i++) lia[i] = target.elementAt(i);
		
		Arrays.sort(lia, lic);
		
		target.removeAllElements();
		for (int i = 0; i < lia.length; i++) target.add(lia[i]);
	}
	
	private static void getLevels(String dir, Vector<LevelInfo> target) {
		FileSystemView fsw = FileSystemView.getFileSystemView();
		File[] files = fsw.getFiles(new File(dir), false);
		for (File f : files) {
			if (!f.getAbsolutePath().endsWith(".js8l")) continue;
			LevelInfo li = new LevelInfo(f);
			if (li.correct()) target.add(li);
		}
	}
	
	private static void fillCharMap() {
		charMap.put("A", new Rectangle(  0,   0, 17,32));
		charMap.put("a", new Rectangle( 17,   0, 17,32));
		charMap.put("B", new Rectangle( 34,   0, 17,32));
		charMap.put("b", new Rectangle( 51,   0, 17,32));
		charMap.put("C", new Rectangle( 68,   0, 17,32));
		charMap.put("c", new Rectangle( 85,   0, 17,32));
		charMap.put("D", new Rectangle(102,   0, 17,32));
		charMap.put("d", new Rectangle(119,   0, 17,32));
		charMap.put("E", new Rectangle(136,   0, 17,32));
		charMap.put("e", new Rectangle(153,   0, 17,32));
		charMap.put("F", new Rectangle(170,   0, 17,32));
		charMap.put("f", new Rectangle(187,   0, 17,32));
		charMap.put("G", new Rectangle(204,   0, 17,32));
		charMap.put("g", new Rectangle(221,   0, 17,32));
		charMap.put("H", new Rectangle(238,   0, 17,32));
		charMap.put("h", new Rectangle(255,   0, 17,32));
		charMap.put("I", new Rectangle(272,   0, 17,32));
		charMap.put("i", new Rectangle(289,   0, 17,32));
		charMap.put("J", new Rectangle(306,   0, 17,32));
		charMap.put("j", new Rectangle(323,   0, 17,32));
		charMap.put("K", new Rectangle(340,   0, 17,32));
		charMap.put("k", new Rectangle(357,   0, 17,32));
		charMap.put("L", new Rectangle(374,   0, 17,32));
		charMap.put("l", new Rectangle(391,   0, 17,32));
		charMap.put("M", new Rectangle(408,   0, 17,32));
		charMap.put("m", new Rectangle(425,   0, 17,32));
		charMap.put("N", new Rectangle(442,   0, 17,32));
		charMap.put("n", new Rectangle(459,   0, 17,32));
		
		charMap.put("O", new Rectangle(  0,  32, 17,32));
		charMap.put("o", new Rectangle( 17,  32, 17,32));
		charMap.put("P", new Rectangle( 34,  32, 17,32));
		charMap.put("p", new Rectangle( 51,  32, 17,32));
		charMap.put("Q", new Rectangle( 68,  32, 17,32));
		charMap.put("q", new Rectangle( 85,  32, 17,32));
		charMap.put("R", new Rectangle(102,  32, 17,32));
		charMap.put("r", new Rectangle(119,  32, 17,32));
		charMap.put("S", new Rectangle(136,  32, 17,32));
		charMap.put("s", new Rectangle(153,  32, 17,32));
		charMap.put("T", new Rectangle(170,  32, 17,32));
		charMap.put("t", new Rectangle(187,  32, 17,32));
		charMap.put("U", new Rectangle(204,  32, 17,32));
		charMap.put("u", new Rectangle(221,  32, 17,32));
		charMap.put("V", new Rectangle(238,  32, 17,32));
		charMap.put("v", new Rectangle(255,  32, 17,32));
		charMap.put("W", new Rectangle(272,  32, 17,32));
		charMap.put("w", new Rectangle(289,  32, 17,32));
		charMap.put("X", new Rectangle(306,  32, 17,32));
		charMap.put("x", new Rectangle(323,  32, 17,32));
		charMap.put("Y", new Rectangle(340,  32, 17,32));
		charMap.put("y", new Rectangle(357,  32, 17,32));
		charMap.put("Z", new Rectangle(374,  32, 17,32));
		charMap.put("z", new Rectangle(391,  32, 17,32));
		charMap.put("Ä", new Rectangle(408,  32, 17,32));
		charMap.put("ä", new Rectangle(425,  32, 17,32));
		charMap.put("Ö", new Rectangle(442,  32, 17,32));
		charMap.put("ö", new Rectangle(459,  32, 17,32));
		
		charMap.put("Ü", new Rectangle(  0,  64, 17,32));
		charMap.put("ü", new Rectangle( 17,  64, 17,32));
		charMap.put("0", new Rectangle( 34,  64, 17,32));
		charMap.put("1", new Rectangle( 51,  64, 17,32));
		charMap.put("2", new Rectangle( 68,  64, 17,32));
		charMap.put("3", new Rectangle( 85,  64, 17,32));
		charMap.put("4", new Rectangle(102,  64, 17,32));
		charMap.put("5", new Rectangle(119,  64, 17,32));
		charMap.put("6", new Rectangle(136,  64, 17,32));
		charMap.put("7", new Rectangle(153,  64, 17,32));
		charMap.put("8", new Rectangle(170,  64, 17,32));
		charMap.put("9", new Rectangle(187,  64, 17,32));
		charMap.put(";", new Rectangle(204,  64, 17,32));
		charMap.put(",", new Rectangle(221,  64, 17,32));
		charMap.put(":", new Rectangle(238,  64, 17,32));
		charMap.put(".", new Rectangle(255,  64, 17,32));
		charMap.put("_", new Rectangle(272,  64, 17,32));
		charMap.put("-", new Rectangle(289,  64, 17,32));
		charMap.put(" ", new Rectangle(306,  64, 17,32));
		charMap.put("^", new Rectangle(323,  64, 17,32));
		charMap.put("!", new Rectangle(340,  64, 17,32));
		charMap.put("$", new Rectangle(357,  64, 17,32));
		charMap.put("/", new Rectangle(374,  64, 17,32));
		charMap.put("(", new Rectangle(391,  64, 17,32));
		charMap.put("[", new Rectangle(408,  64, 17,32));
		charMap.put(")", new Rectangle(425,  64, 17,32));
		charMap.put("]", new Rectangle(442,  64, 17,32));
		charMap.put("=", new Rectangle(459,  64, 17,32));
		
		charMap.put("\\", new Rectangle(  0,  96, 17,32));
		charMap.put("'", new Rectangle( 17,  96, 17,32));
		charMap.put("@", new Rectangle( 34,  96, 17,32));
		charMap.put("€", new Rectangle( 51,  96, 17,32));
		charMap.put("<", new Rectangle( 68,  96, 17,32));
		charMap.put(">", new Rectangle( 85,  96, 17,32));
		charMap.put("+", new Rectangle(102,  96, 17,32));
		charMap.put("*", new Rectangle(119,  96, 17,32));
		charMap.put("#", new Rectangle(136,  96, 17,32));
		charMap.put("ß", new Rectangle(170,  96, 17,32));
	}
	
	private static void fillKeyCodes() {
		keyCodes.put("0", KeyEvent.VK_0); 
		keyCodes.put("1", KeyEvent.VK_1); 
		keyCodes.put("2", KeyEvent.VK_2);
		keyCodes.put("3", KeyEvent.VK_3);
		keyCodes.put("4", KeyEvent.VK_4);
		keyCodes.put("5", KeyEvent.VK_5);
		keyCodes.put("6", KeyEvent.VK_6);
		keyCodes.put("7", KeyEvent.VK_7);
		keyCodes.put("8", KeyEvent.VK_8);
		keyCodes.put("9", KeyEvent.VK_9);
		keyCodes.put("A", KeyEvent.VK_A);
		keyCodes.put("ACCEPT", KeyEvent.VK_ACCEPT);
		keyCodes.put("ADD", KeyEvent.VK_ADD);
		keyCodes.put("AGAIN", KeyEvent.VK_AGAIN);
		keyCodes.put("ALL_CANDIDATES", KeyEvent.VK_ALL_CANDIDATES);
		keyCodes.put("ALPHANUMERIC", KeyEvent.VK_ALPHANUMERIC);
		keyCodes.put("ALT", KeyEvent.VK_ALT);
		keyCodes.put("ALT_GRAPH", KeyEvent.VK_ALT_GRAPH);
		keyCodes.put("AMPERSAND", KeyEvent.VK_AMPERSAND);
		keyCodes.put("ASTERISK", KeyEvent.VK_ASTERISK);
		keyCodes.put("AT", KeyEvent.VK_AT);
		keyCodes.put("B", KeyEvent.VK_B);
		keyCodes.put("BACK_QUOTE", KeyEvent.VK_BACK_QUOTE);
		keyCodes.put("BACK_SLASH", KeyEvent.VK_BACK_SLASH);
		keyCodes.put("BACK_SPACE", KeyEvent.VK_BACK_SPACE);
		keyCodes.put("BEGIN", KeyEvent.VK_BEGIN);
		keyCodes.put("BRACELEFT", KeyEvent.VK_BRACELEFT);
		keyCodes.put("BRACERIGHT", KeyEvent.VK_BRACERIGHT);
		keyCodes.put("C", KeyEvent.VK_C);
		keyCodes.put("CANCEL", KeyEvent.VK_CANCEL);
		keyCodes.put("CAPS_LOCK", KeyEvent.VK_CAPS_LOCK);
		keyCodes.put("CIRCUMFLEX", KeyEvent.VK_CIRCUMFLEX);
		keyCodes.put("CLEAR", KeyEvent.VK_CLEAR);
		keyCodes.put("CLOSE_BRACKET", KeyEvent.VK_CLOSE_BRACKET);
		keyCodes.put("CODE_INPUT", KeyEvent.VK_CODE_INPUT);
		keyCodes.put("COLON", KeyEvent.VK_COLON);
		keyCodes.put("COMMA", KeyEvent.VK_COMMA);
		keyCodes.put("COMPOSE", KeyEvent.VK_COMPOSE);
		keyCodes.put("CONTEXT_MENU", KeyEvent.VK_CONTEXT_MENU);
		keyCodes.put("CONTROL", KeyEvent.VK_CONTROL);
		keyCodes.put("CONVERT", KeyEvent.VK_CONVERT);
		keyCodes.put("COPY", KeyEvent.VK_COPY);
		keyCodes.put("CUT", KeyEvent.VK_CUT);
		keyCodes.put("D", KeyEvent.VK_D);
		keyCodes.put("DEAD_ABOVEDOT", KeyEvent.VK_DEAD_ABOVEDOT);
		keyCodes.put("DEAD_ABOVERING", KeyEvent.VK_DEAD_ABOVERING);
		keyCodes.put("DEAD_ACUTE", KeyEvent.VK_DEAD_ACUTE);
		keyCodes.put("DEAD_BREVE", KeyEvent.VK_DEAD_BREVE);
		keyCodes.put("DEAD_CARON", KeyEvent.VK_DEAD_CARON);
		keyCodes.put("DEAD_CEDILLA", KeyEvent.VK_DEAD_CEDILLA);
		keyCodes.put("DEAD_CIRCUMFLEX", KeyEvent.VK_DEAD_CIRCUMFLEX);
		keyCodes.put("DEAD_DIAERESIS", KeyEvent.VK_DEAD_DIAERESIS);
		keyCodes.put("DEAD_DOUBLEACUTE", KeyEvent.VK_DEAD_DOUBLEACUTE);
		keyCodes.put("DEAD_GRAVE", KeyEvent.VK_DEAD_GRAVE);
		keyCodes.put("DEAD_IOTA", KeyEvent.VK_DEAD_IOTA);
		keyCodes.put("DEAD_MACRON", KeyEvent.VK_DEAD_MACRON);
		keyCodes.put("DEAD_OGONEK", KeyEvent.VK_DEAD_OGONEK);
		keyCodes.put("DEAD_SEMIVOICED_SOUND", KeyEvent.VK_DEAD_SEMIVOICED_SOUND);
		keyCodes.put("DEAD_TILDE", KeyEvent.VK_DEAD_TILDE);
		keyCodes.put("DEAD_VOICED_SOUND", KeyEvent.VK_DEAD_VOICED_SOUND);
		keyCodes.put("DECIMAL", KeyEvent.VK_DECIMAL);
		keyCodes.put("DELETE", KeyEvent.VK_DELETE);
		keyCodes.put("DIVIDE", KeyEvent.VK_DIVIDE);
		keyCodes.put("DOLLAR", KeyEvent.VK_DOLLAR);
		keyCodes.put("DOWN", KeyEvent.VK_DOWN);
		keyCodes.put("E", KeyEvent.VK_E);
		keyCodes.put("END", KeyEvent.VK_END);
		keyCodes.put("ENTER", KeyEvent.VK_ENTER);
		keyCodes.put("EQUALS", KeyEvent.VK_EQUALS);
		keyCodes.put("ESCAPE", KeyEvent.VK_ESCAPE);
		keyCodes.put("EURO_SIGN", KeyEvent.VK_EURO_SIGN);
		keyCodes.put("EXCLAMATION_MARK", KeyEvent.VK_EXCLAMATION_MARK);
		keyCodes.put("F", KeyEvent.VK_F);
		keyCodes.put("F1", KeyEvent.VK_F1);
		keyCodes.put("F10", KeyEvent.VK_F10);
		keyCodes.put("F11", KeyEvent.VK_F11);
		keyCodes.put("F12", KeyEvent.VK_F12);
		keyCodes.put("F13", KeyEvent.VK_F13);
		keyCodes.put("F14", KeyEvent.VK_F14);
		keyCodes.put("F15", KeyEvent.VK_F15);
		keyCodes.put("F16", KeyEvent.VK_F16);
		keyCodes.put("F17", KeyEvent.VK_F17);
		keyCodes.put("F18", KeyEvent.VK_F18);
		keyCodes.put("F19", KeyEvent.VK_F19);
		keyCodes.put("F2", KeyEvent.VK_F2);
		keyCodes.put("F20", KeyEvent.VK_F20);
		keyCodes.put("F21", KeyEvent.VK_F21);
		keyCodes.put("F22", KeyEvent.VK_F22);
		keyCodes.put("F23", KeyEvent.VK_F23);
		keyCodes.put("F24", KeyEvent.VK_F24);
		keyCodes.put("F3", KeyEvent.VK_F3);
		keyCodes.put("F4", KeyEvent.VK_F4);
		keyCodes.put("F5", KeyEvent.VK_F5);
		keyCodes.put("F6", KeyEvent.VK_F6);
		keyCodes.put("F7", KeyEvent.VK_F7);
		keyCodes.put("F8", KeyEvent.VK_F8);
		keyCodes.put("F9", KeyEvent.VK_F9);
		keyCodes.put("FINAL", KeyEvent.VK_FINAL);
		keyCodes.put("FIND", KeyEvent.VK_FIND);
		keyCodes.put("FULL_WIDTH", KeyEvent.VK_FULL_WIDTH);
		keyCodes.put("G", KeyEvent.VK_G);
		keyCodes.put("GREATER", KeyEvent.VK_GREATER);
		keyCodes.put("H", KeyEvent.VK_H);
		keyCodes.put("HALF_WIDTH", KeyEvent.VK_HALF_WIDTH);
		keyCodes.put("HELP", KeyEvent.VK_HELP);
		keyCodes.put("HIRAGANA", KeyEvent.VK_HIRAGANA);
		keyCodes.put("HOME", KeyEvent.VK_HOME);
		keyCodes.put("I", KeyEvent.VK_I);
		keyCodes.put("INPUT_METHOD_ON_OFF", KeyEvent.VK_INPUT_METHOD_ON_OFF);
		keyCodes.put("INSERT", KeyEvent.VK_INSERT);
		keyCodes.put("INVERTED_EXCLAMATION_MARK", KeyEvent.VK_INVERTED_EXCLAMATION_MARK);
		keyCodes.put("J", KeyEvent.VK_J);
		keyCodes.put("JAPANESE_HIRAGANA", KeyEvent.VK_JAPANESE_HIRAGANA);
		keyCodes.put("JAPANESE_KATAKANA", KeyEvent.VK_JAPANESE_KATAKANA);
		keyCodes.put("JAPANESE_ROMAN", KeyEvent.VK_JAPANESE_ROMAN);
		keyCodes.put("K", KeyEvent.VK_K);
		keyCodes.put("KANA", KeyEvent.VK_KANA);
		keyCodes.put("KANA_LOCK", KeyEvent.VK_KANA_LOCK);
		keyCodes.put("KANJI", KeyEvent.VK_KANJI);
		keyCodes.put("KATAKANA", KeyEvent.VK_KATAKANA);
		keyCodes.put("KP_DOWN", KeyEvent.VK_KP_DOWN);
		keyCodes.put("KP_LEFT", KeyEvent.VK_KP_LEFT);
		keyCodes.put("KP_RIGHT", KeyEvent.VK_KP_RIGHT);
		keyCodes.put("KP_UP", KeyEvent.VK_KP_UP);
		keyCodes.put("L", KeyEvent.VK_L);
		keyCodes.put("LEFT", KeyEvent.VK_LEFT);
		keyCodes.put("LEFT_PARENTHESIS", KeyEvent.VK_LEFT_PARENTHESIS);
		keyCodes.put("LESS", KeyEvent.VK_LESS);
		keyCodes.put("M", KeyEvent.VK_M);
		keyCodes.put("META", KeyEvent.VK_META);
		keyCodes.put("MINUS", KeyEvent.VK_MINUS);
		keyCodes.put("MODECHANGE", KeyEvent.VK_MODECHANGE);
		keyCodes.put("MULTIPLY", KeyEvent.VK_MULTIPLY);
		keyCodes.put("N", KeyEvent.VK_N);
		keyCodes.put("NONCONVERT", KeyEvent.VK_NONCONVERT);
		keyCodes.put("NUM_LOCK", KeyEvent.VK_NUM_LOCK);
		keyCodes.put("NUMBER_SIGN", KeyEvent.VK_NUMBER_SIGN);
		keyCodes.put("NUMPAD0", KeyEvent.VK_NUMPAD0);
		keyCodes.put("NUMPAD1", KeyEvent.VK_NUMPAD1);
		keyCodes.put("NUMPAD2", KeyEvent.VK_NUMPAD2);
		keyCodes.put("NUMPAD3", KeyEvent.VK_NUMPAD3);
		keyCodes.put("NUMPAD4", KeyEvent.VK_NUMPAD4);
		keyCodes.put("NUMPAD5", KeyEvent.VK_NUMPAD5);
		keyCodes.put("NUMPAD6", KeyEvent.VK_NUMPAD6);
		keyCodes.put("NUMPAD7", KeyEvent.VK_NUMPAD7);
		keyCodes.put("NUMPAD8", KeyEvent.VK_NUMPAD8);
		keyCodes.put("NUMPAD9", KeyEvent.VK_NUMPAD9);
		keyCodes.put("O", KeyEvent.VK_O);
		keyCodes.put("OPEN_BRACKET", KeyEvent.VK_OPEN_BRACKET);
		keyCodes.put("P", KeyEvent.VK_P);
		keyCodes.put("PAGE_DOWN", KeyEvent.VK_PAGE_DOWN);
		keyCodes.put("PAGE_UP", KeyEvent.VK_PAGE_UP);
		keyCodes.put("PASTE", KeyEvent.VK_PASTE);
		keyCodes.put("PAUSE", KeyEvent.VK_PAUSE);
		keyCodes.put("PERIOD", KeyEvent.VK_PERIOD);
		keyCodes.put("PLUS", KeyEvent.VK_PLUS);
		keyCodes.put("PREVIOUS_CANDIDATE", KeyEvent.VK_PREVIOUS_CANDIDATE);
		keyCodes.put("PRINTSCREEN", KeyEvent.VK_PRINTSCREEN);
		keyCodes.put("PROPS", KeyEvent.VK_PROPS);
		keyCodes.put("Q", KeyEvent.VK_Q);
		keyCodes.put("QUOTE", KeyEvent.VK_QUOTE);
		keyCodes.put("QUOTEDBL", KeyEvent.VK_QUOTEDBL);
		keyCodes.put("R", KeyEvent.VK_R);
		keyCodes.put("RIGHT", KeyEvent.VK_RIGHT);
		keyCodes.put("RIGHT_PARENTHESIS", KeyEvent.VK_RIGHT_PARENTHESIS);
		keyCodes.put("ROMAN_CHARACTERS", KeyEvent.VK_ROMAN_CHARACTERS);
		keyCodes.put("S", KeyEvent.VK_S);
		keyCodes.put("SCROLL_LOCK", KeyEvent.VK_SCROLL_LOCK);
		keyCodes.put("SEMICOLON", KeyEvent.VK_SEMICOLON);
		keyCodes.put("SEPARATOR", KeyEvent.VK_SEPARATOR);
		keyCodes.put("SHIFT", KeyEvent.VK_SHIFT);
		keyCodes.put("SLASH", KeyEvent.VK_SLASH);
		keyCodes.put("SPACE", KeyEvent.VK_SPACE);
		keyCodes.put("STOP", KeyEvent.VK_STOP);
		keyCodes.put("SUBTRACT", KeyEvent.VK_SUBTRACT);
		keyCodes.put("T", KeyEvent.VK_T);
		keyCodes.put("TAB", KeyEvent.VK_TAB);
		keyCodes.put("U", KeyEvent.VK_U);
		keyCodes.put("UNDEFINED", KeyEvent.VK_UNDEFINED);
		keyCodes.put("UNDERSCORE", KeyEvent.VK_UNDERSCORE);
		keyCodes.put("UNDO", KeyEvent.VK_UNDO);
		keyCodes.put("UP", KeyEvent.VK_UP);
		keyCodes.put("V", KeyEvent.VK_V);
		keyCodes.put("W", KeyEvent.VK_W);
		keyCodes.put("WINDOWS", KeyEvent.VK_WINDOWS);
		keyCodes.put("X", KeyEvent.VK_X);
		keyCodes.put("Y", KeyEvent.VK_Y);
		keyCodes.put("Z", KeyEvent.VK_Z);
	}
	//Get the absolute path of the current directory. GAMEROOT will end with an "/".
	private static void getGameRoot() {
		String programName ="Main.class";
		String pathSep = System.getProperties().getProperty("path.separator");
		String[] classPath = System.getProperties().getProperty("java.class.path").split(pathSep);
		for (String cp: classPath) {
			if (cp.endsWith(programName))
				System.out.println(cp.substring(0, (cp.length() - programName.length())));
		}
		GAMEROOT = "/"+(System.getProperties().getProperty("user.dir") + System.getProperties().getProperty("file.separator"));
		GAMEROOT = GAMEROOT.replace('\\', '/');
		GAMEROOT = GAMEROOT.replaceAll(" ", "%20");
		GAMEROOT = GAMEROOT.replaceFirst("//", "/");
	}
}