/*(c) Jippy Snake 8 Developmentteam.
 *
 *
 * This code is published unter GNU Public Licence v2.
 *
 *
 */

import java.io.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import java.util.HashMap;

class Language {
	private HashMap<String, String> translations;
	
	public Language(String lang) {
		translations = new HashMap<String, String>();
		try {
			Document lvlDocument = DocumentBuilderFactory.newInstance().newDocumentBuilder().parse(new File(Globals.GAMEROOT+"language/"+lang+".xml"));
			Element rootElem = lvlDocument.getDocumentElement();
			if (rootElem.getTagName().equals("js8language")) {
				NodeList infos = lvlDocument.getElementsByTagName("text");
				for (int i = 0; i < infos.getLength(); i++) {
					if (infos.item(i).getNodeType() != Node.ELEMENT_NODE) continue;
					Element e = (Element) infos.item(i);
					translations.put(e.getAttribute("key"), e.getAttribute("text"));
				}
			} else {
				System.out.println("given LanguageFile is not a language file!");
				System.exit(1);
			}
		} catch(Exception e ) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	public String translate(String key) {
		String text = translations.get(key);
		if (text == null) return key;
		return text;
	}
}
