/*(c) Jippy Snake 8 Developmentteam.
 *
 *
 * This code is published unter GNU Public Licence v2.
 *
 *
 */

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.HashMap;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.filechooser.*;

class LevelEditor extends JFrame {
	//Elementary stuff
	private JS8Level level;
	private int tiles[][][];
	private Language lang;
	private Renderer wRend;
	private Renderer tRend;
	private HashMap<Integer, Integer> textureCodes; //We use logical texturenumbers here, so we need to translate the logical to the reasl texture-numbers
	
	private int curTileNum; //contains the current tile, that is drawed
	private float scale;
	
	private boolean moveFill;
	
	//Tab for level-editing
	private Canvas work = new Canvas() {
		public void paint(Graphics g) {
			flushLevel();
		}
	};
	private JLabel lMaxLayer;
	private JSpinner spMaxLayer;
	private JLabel lCurLayer;
	private JSpinner spCurLayer;
	
	//Tab for tile-choosing
	private Canvas cTiles = new Canvas() {
		public void paint(Graphics g) {
			drawTiles();
		}
	};
	
	//Tab for control
	//Labels for level-infos:
	private JLabel lName;
	private JLabel lAuthor;
	private JLabel lStartNewApples;
	private JLabel lFuncNewApples;
	private JLabel lStartApplesTillNew;
	private JLabel lFuncApplesTillNew;
	private JLabel lBlind;
	private JLabel lTime;
	
	//configFields for level-infos
	private JTextField tfName;
	private JTextField tfAuthor;
	private JSpinner   spStartNewApples;
	private JTextField tfFuncNewApples;
	private JSpinner   spStartApplesTillNew;
	private JTextField tfFuncApplesTillNew;
	private JCheckBox  cbBlind;
	private JSpinner   spTime;
	
	//Controlbuttons
	private JButton bLoad;
	private JButton bSave;
	private JButton bExit;
	
	public LevelEditor(Language l, int size) {
		lang = l;
		textureCodes = new HashMap<Integer, Integer>();
		tiles = new int[7][16][25];
		scale = (float) 1920.0/size;
		
		work.setSize((int) (25.0*size/30.0), (int) (16.0*size/30.0));
		cTiles.setSize((int) (25.0*size/30.0), (int) (16.0*size/30.0));
		
		JTabbedPane tabPane = new JTabbedPane();
		
		//create and set work work-tab
		lMaxLayer = new JLabel(lang.translate("MAXLAYER"));
		spMaxLayer = new JSpinner(new SpinnerNumberModel(4,0,4,1));
		lCurLayer = new JLabel(lang.translate("CURLAYER"));
		spCurLayer = new JSpinner(new SpinnerNumberModel(-1,-1,4,1));
		
		JPanel workPanel = new JPanel();
		workPanel.setLayout(new BorderLayout());
		workPanel.add(work, BorderLayout.CENTER);
		JPanel layerPanel = new JPanel();
		layerPanel.setLayout(new GridLayout(4,1));
		layerPanel.add(lMaxLayer);
		layerPanel.add(spMaxLayer);
		layerPanel.add(lCurLayer);
		layerPanel.add(spCurLayer);
		
		bLoad = new JButton(lang.translate("LOAD"));
		bSave = new JButton(lang.translate("SAVE"));
		bExit = new JButton(lang.translate("EXIT"));
		JPanel buttonsPanel = new JPanel();
		buttonsPanel.setLayout(new GridLayout(3,1));
		buttonsPanel.add(bLoad);
		buttonsPanel.add(bSave);
		buttonsPanel.add(bExit);
		
		JPanel layerControlPanel = new JPanel();
		
		layerControlPanel.setLayout(new BorderLayout());
		layerControlPanel.add(layerPanel, BorderLayout.NORTH);
		layerControlPanel.add(buttonsPanel, BorderLayout.SOUTH);
		workPanel.add(layerControlPanel, BorderLayout.EAST);

		tabPane.addTab(lang.translate("LEVEL"), workPanel);
		
		//create and add tile-tab
		JPanel tilePanel = new JPanel();
		
		tilePanel.setLayout(new BorderLayout());
		tilePanel.add(cTiles, BorderLayout.CENTER);
		tabPane.addTab(lang.translate("TILES"), tilePanel);
		
		//create and add levelinfo-tab
		//create all labels
		lName = new JLabel(lang.translate("NAME"));
		lAuthor = new JLabel(lang.translate("AUTHOR"));
		lStartNewApples = new JLabel(lang.translate("STARTNEWAPPLES"));
		lFuncNewApples = new JLabel(lang.translate("FUNCNEWAPPLES"));
		lStartApplesTillNew = new JLabel(lang.translate("STARTAPPLESTILLNEW"));
		lFuncApplesTillNew = new JLabel(lang.translate("FUNCAPPLESTILLNEW"));
		lBlind = new JLabel(lang.translate("BLIND"));
		lTime = new JLabel(lang.translate("TIME"));
		
		//Create configFields
		tfName = new JTextField();
		tfAuthor = new JTextField();
		spStartNewApples = new JSpinner(new SpinnerNumberModel(1, 1, 100, 1));
		tfFuncNewApples = new JTextField();
		spStartApplesTillNew = new JSpinner(new SpinnerNumberModel(1, 1, 100, 1));
		tfFuncApplesTillNew = new JTextField();
		cbBlind = new JCheckBox();
		spTime = new JSpinner(new SpinnerNumberModel(-1, -1, 100000, 1));
		
		//Create control-buttons
		JPanel controlPanel = new JPanel();
		controlPanel.setLayout(new BorderLayout());
		
		JPanel infoPanel = new JPanel();
		infoPanel.setLayout(new GridLayout(8,2));
		
		//Layout all elements
		infoPanel.add(lName);
		infoPanel.add(tfName);
		infoPanel.add(lAuthor);
		infoPanel.add(tfAuthor);
		
		infoPanel.add(lStartNewApples);
		infoPanel.add(spStartNewApples);
		infoPanel.add(lFuncNewApples);
		infoPanel.add(tfFuncNewApples);
		
		infoPanel.add(lStartApplesTillNew);
		infoPanel.add(spStartApplesTillNew);
		infoPanel.add(lFuncApplesTillNew);
		infoPanel.add(tfFuncApplesTillNew);
		
		infoPanel.add(lBlind);
		infoPanel.add(cbBlind);
		infoPanel.add(lTime);
		infoPanel.add(spTime);
		
		controlPanel.add(infoPanel, BorderLayout.NORTH);
		
		tabPane.addTab(lang.translate("LEVELINFO"), controlPanel);
		
		setLayout(new GridLayout(1,1));
		add(tabPane);
		
		setTitle("Jippy Snake 8 - Leveleditor");
		
		pack();
		setVisible(true);
		wRend = new Renderer(work, "graphics/legraphics.xml", "");
		tRend = new Renderer(cTiles, "graphics/legraphics.xml", "");
		wRend.setScale((float) (1/scale));
		tRend.setScale((float) (1/scale));
		
		//generate logical-texture -> realTexture map
		int posx = 0;
		int posy = 0;
		for (int type = 0; type < 6; type++) {
			for (int txt = 0; txt+type < 1000; txt+=6) {
				if (tRend.isTexture(txt+type)) {
					textureCodes.put(20*posy+posx,txt+type);
					posx++;
				}
				if (posx == 20) {
					posx = 0;
					posy++;
				}
			}
			posy++;
			posx = 0;
		}
		drawTiles();
		renderLevel();
		
		//Set actionlisteners
		tabPane.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				drawTiles();
				renderLevel();
			}
		});
		bExit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				exitLE();
			}
		});
		
		bSave.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				writeLevel();
			}
		});
		
		bLoad.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				loadLevel();
			}
		});
		
		spMaxLayer.addChangeListener(new ChangeListener()  {
			public void stateChanged(ChangeEvent e) {
				changeMaxLayer();
			}
		});
		spCurLayer.addChangeListener(new ChangeListener()  {
			public void stateChanged(ChangeEvent e) {
				showLevel();
			}
		});
		
		work.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				if (e.getButton() == MouseEvent.BUTTON1) {
					wClick(e.getX(), e.getY());
				}
				else if (e.getButton() == MouseEvent.BUTTON2)
					fillLayer();
				else if (e.getButton() == MouseEvent.BUTTON3)
					setMoveFill();
			}
		});
		work.addMouseMotionListener(new MouseAdapter() {
			public void mouseMoved(MouseEvent e) {
				wMove(e.getX(), e.getY());
			}
		});
		cTiles.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				tClick(e.getX(), e.getY());
			}
		});
		
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				exitLE();
			}
		});
	}
	
	private void setMoveFill() {
		moveFill = !moveFill;
	}
	
	private void renderLevel() {
		wRend.setNumLayers(((Integer) spMaxLayer.getValue())+2);
		drawLevel();
	}
	
	private void changeMaxLayer() {
		spCurLayer.setValue(Math.min((Integer) spCurLayer.getValue(), ((Integer) spMaxLayer.getValue())));
		((SpinnerNumberModel) spCurLayer.getModel()).setMaximum(((Integer) spMaxLayer.getValue()));
		renderLevel();
	}
	
	private void tClick(int x, int y) {
		setTileNum((int) (x*scale), (int) (y*scale));
	}
	
	private void wClick(int x, int y) {
		drawTile((int) (x*scale), (int) (y*scale));
	}
	
	private void wMove(int x, int y) {
		if (!moveFill) return;
		drawTile((int) (x*scale), (int) (y*scale));
	}
	
	private void drawTile(int x, int y) {
		if (curTileNum == -1) return;
		int tx = x/64;
		int ty = y/64;
		if (tx > 24) return;
		if (ty > 15) return;
		tiles[((Integer) spCurLayer.getValue())+1][ty][tx] = curTileNum;
		drawLevelLayer(((Integer) spCurLayer.getValue())+1);
		showLevel();
	}
	
	private void fillLayer() {
		if (curTileNum == -1) return;
		for (int x = 0; x < 25; x++)
		for (int y = 0; y < 16; y++)
			tiles[((Integer) spCurLayer.getValue())+1][y][x] = curTileNum;
		drawLevelLayer(((Integer) spCurLayer.getValue())+1);
		showLevel();
	}
	
	private void setTileNum(int x, int y) {
		int tx = x/80;
		int ty = y/80;
		if (tx > 19) return;
		if (ty > 11) return;
		int tileNum = 20*ty+tx;
		Integer i = textureCodes.get(tileNum);
		if (i == null) return;
		else curTileNum = i;
		tRend.reNewLayer(1);
		tRend.drawImage(1,1000, 80*tx,80*ty);
		tRend.drawScreen();
	}
	
	private void drawTiles() {
		if (tRend == null) return;
		tRend.drawRect(0, new Color(192,192,255), 0,0, 1600,1024);
		Integer txtnum;
		for (int i = 0; i < 1000; i++) {
			txtnum = textureCodes.get(i);
			if (txtnum == null) continue;
			int drawX = i%20;
			int drawY = i/20;
			tRend.drawImage(0, txtnum, 80*drawX, 80*drawY);
		}
		tRend.drawScreen();
	}
	
	private void drawLevel() {
		if (wRend == null) return;
		wRend.drawRect(0, Color.BLACK, 0,0, 1600, 1024);
		for (int l = 0; l < ((Integer) spMaxLayer.getValue())+2; l++) {
			drawLevelLayer(l);
		}
		showLevel();
	}
	
	private void drawLevelLayer(int l) {
		if (l > 0) wRend.reNewLayer(l);
		else wRend.drawRect(0, Color.BLACK, 0,0, 1600, 1024);
		
		for (int x = 0; x < 25; x++)
		for (int y = 0; y < 16; y++) {
			wRend.drawImage(l, tiles[l][y][x], 64*x,64*y);
		}
	}
	
	private void showLevel() {
		wRend.drawRectOnScreen(Color.BLACK, 0,0, 1600,1024);
		for (int l = 0; l < ((Integer) spMaxLayer.getValue())+2; l++) {
			wRend.preRenderLayer(l, -16*l+16*((Integer) spCurLayer.getValue()+1));
		}
		wRend.flushScreen();
	}
	
	private void loadLevel() {
		int retVal = 999;
		
		//choose file to load
		JFileChooser fileChoose = new JFileChooser();
		fileChoose.setCurrentDirectory(new File(Globals.OWNLEVELFOLDER));
		try {
			retVal = fileChoose.showOpenDialog(this);
		} catch (Exception e) {
		}
		if (retVal != JFileChooser.APPROVE_OPTION) return;
		
		level = new JS8Level(fileChoose.getSelectedFile());
		if (!level.isValid()) return;
		
		//get Tiles
		int maxLayer = 0;
		for (Coord c : Coord.range(new Coord(0,0,-1), new Coord(24,15,5))) {
			tiles[c.getZ()+1][c.getY()][c.getX()] = level.getTile(c, true);
			if ((tiles[c.getZ()+1][c.getY()][c.getX()] != 0) && (c.getZ() > maxLayer)) maxLayer = c.getZ();
		}
		
		//get infos:
		tfName.setText(level.getName());
		tfAuthor.setText(level.getAuthor());
		((SpinnerNumberModel) spStartNewApples.getModel()).setValue((Integer) level.getNewApples());
		tfFuncNewApples.setText(level.getFuncNewApples());
		((SpinnerNumberModel) spStartApplesTillNew.getModel()).setValue((Integer) level.getApplesTillNew());
		tfFuncApplesTillNew.setText(level.getFuncApplesTillNew());
		cbBlind.setSelected(level.isBlind());
		((SpinnerNumberModel) spTime.getModel()).setValue((Integer) level.getLevelTime());
		((SpinnerNumberModel) spMaxLayer.getModel()).setValue(maxLayer);
		changeMaxLayer();
	}
	
	public void writeLevel() {
		//Check and fix data, f possible, othweise exit method
		if (tfName.getText().equals("")) return;
		if (tfFuncNewApples.getText().equals("")) tfFuncNewApples.setText("prev");
		if (tfFuncApplesTillNew.getText().equals("")) tfFuncApplesTillNew.setText("prev");
		
		boolean overwrite = true;
		String fileName = tfName.getText()+".js8l";
		fileName = fileName.replaceAll("/", "");
		File f = new File(Globals.OWNLEVELFOLDER+fileName);
		//If levelfile exists, aks for overwrite
		if (f.exists()) {
			overwrite = false;
			try  {
				int res = JOptionPane.showConfirmDialog(this,
				                                        lang.translate("FILEEXISTS")+". "+lang.translate("OVERWRITE")+"?",
				                                        lang.translate("OVERWRITE")+"?",
				                                        JOptionPane.YES_NO_OPTION,
				                                        JOptionPane.QUESTION_MESSAGE);
				if (res == JOptionPane.YES_OPTION) overwrite = true;
			} catch (Exception e) {
			}
		}
		if (!overwrite) return;
		
		try {
			FileWriter fw = new FileWriter(f);
			BufferedWriter buffw = new BufferedWriter(fw);
			//Write intro
			buffw.write("<?xml version=\"1.0\" encoding=\""+fw.getEncoding()+"\"?>\n\n<js8level>\n");
			
			//write infos
			if (!tfAuthor.getText().equals("")) buffw.write("<info type=\"author\" content=\""+maskXMLChars(tfAuthor.getText())+"\" />\n");
			buffw.write("<info type=\"name\" content=\""+maskXMLChars(tfName.getText().replaceAll("/", ""))+"\" />\n");
			buffw.write("<info type=\"startNewApples\" content=\""+spStartNewApples.getValue()+"\" />\n");
			buffw.write("<info type=\"funcNewApples\" content=\""+maskXMLChars(tfFuncNewApples.getText())+"\" />\n");
			buffw.write("<info type=\"startApplesTillNew\" content=\""+spStartApplesTillNew.getValue()+"\" />\n");
			buffw.write("<info type=\"funcApplesTillNew\" content=\""+maskXMLChars(tfFuncApplesTillNew.getText())+"\" />\n");
			buffw.write("<info type=\"blind\" content=\""+cbBlind.isSelected()+"\" />\n");
			buffw.write("<info type=\"time\" content=\""+spTime.getValue()+"\" />\n");
			//write tiles: it uses a simple algorythm to minimize the level files
			boolean written[][][] = new boolean[7][16][25];
			for (int z = 0; z <  7; z++)
			for (int y = 0; y < 16; y++)
			for (int x = 0; x < 25; x++) {
				if (!written[z][y][x]) {
					int ex, ey, ez;
					//Search for endpositions of a quad
					ex = x;
					ey = y;
					ez = z;
					while ((ex < 24) && (tiles[z][y][x] == tiles[z][y][ex+1])) ex++;
					while ((ey < 15) && checkQuad(tiles[z][y][x], x,ey+1,z, ex,ey+1,z)) ey++;
					while ((ez <  6) && checkQuad(tiles[z][y][x], x,y,ez+1, ex,ey,ez+1)) ez++;
					
					//Write found quad
					buffw.write("<quad sx=\""+x+"\" sy=\""+y+"\" sz=\""+(z-1)+"\" ex=\""+ex+"\" ey=\""+ey+"\" ez=\""+(ez-1)+"\" fill=\""+tiles[z][y][x]+"\" />\n");
					
					//set the quad as written
					for (int wz = z; wz <= ez; wz++)
					for (int wy = y; wy <= ey; wy++)
					for (int wx = x; wx <= ex; wx++)
						written[wz][wy][wx] = true;
				}
			}
			
			//write end and flush
			buffw.write("</js8level>");
			buffw.flush();
			buffw.close();
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}
	}
	
	private String maskXMLChars(String text) {
		if (text == null) return null;
		String ret = text+"";
		ret = ret.replaceAll("&", "&#38;");
		ret = ret.replaceAll("<", "&#60;");
		ret = ret.replaceAll(">", "&#62;");
		ret = ret.replaceAll("=", "&#61;");
		ret = ret.replaceAll("\"", "&#34;");
		return ret;
	}
	
	//Checks if all elements of the quad given by (sx,sy,ez),(ex,ey,ez) has the tilenumber tile
	private boolean checkQuad(int tile, int sx, int sy, int sz, int ex, int ey, int ez) {
		boolean ret = true;
		for (int z = sz; z <= ez; z++)
		for (int y = sy; y <= ey; y++)
		for (int x = sx; x <= ex; x++)
			if (tiles[z][y][x] != tile) ret = false;
		
		return ret;
	}
	
	private void flushLevel() {
		if (wRend == null) return;
		wRend.flushScreen();
	}
	
	private void showTiles() {
		if (tRend == null) return;
		tRend.flushScreen();
	}
	
	private void exitLE() {
		System.exit(0);
	}
} 
