/*(c) Jippy Snake 8 Developmentteam.
 *
 *
 * This code is published unter GNU Public Licence v2.
 *
 *
 */

import java.io.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import java.util.Comparator;

class LevelInfo {
	private String lvlName;
	private String lvlAuthor;
	
	private boolean lvlCorrect;
	
	private File lvlFile;
	
	public LevelInfo(File lvlFile) {
		lvlName = "";
		lvlAuthor = "";
		
		//Check an read the levelfile
		lvlCorrect = false;
		try {
			Document lvlDocument = DocumentBuilderFactory.newInstance().newDocumentBuilder().parse(lvlFile);
			Element rootElem = lvlDocument.getDocumentElement();
			if (rootElem.getTagName().equals("js8level")) {
				NodeList infos = lvlDocument.getElementsByTagName("info");
				for (int i = 0; i < infos.getLength(); i++) {
					if (infos.item(i).getNodeType() != Node.ELEMENT_NODE) continue;
					Element e = (Element) infos.item(i);
					if (e.getAttribute("type").equals("author")) lvlAuthor = e.getAttribute("content");
					if (e.getAttribute("type").equals("name")) lvlName = e.getAttribute("content");
				}
				//Here we readed level data correctly
				lvlCorrect = true;
				//Now fill the levelInfo with the infos from Player
				this.lvlFile = lvlFile;
			}
		} catch( Throwable t ) {
			//Here something was wrong.
		}
	}
	
	public File getFile() {
		return lvlFile;
	}
	public boolean correct() {
		return lvlCorrect;
	}
	public String getName() {
		return lvlName;
	}
	public String getAuthor() {
		return lvlAuthor;
	}
}
