/*(c) JippySnake7 Developmentteam.
 *
 *
 * This code is published unter GNU Public Licence v2.
 *
 *
 */
import java.util.Vector;

class Snake {
	private SnakeHead head;
	private SnakeBody body;
	private int length;
	
	public Snake(Coord headPos) {
		head = new SnakeHead(headPos);
		clear();
	}
	
	public int getLength() {
		return length;
	}
	
	//clears the snake
	public void clear() {
		body = new SnakeBody();
		length = 0;
	}
	
	//moves the Snake
	public void move(Coord dir) {
		body.move(head.getPos());
		head.setPos(head.getPos().add(dir));
	}
	
	//grows the snake
	public void grow(Coord crd) {
		body.addElement(crd);
		length++;
	}
	
	//Set texture for head
	public void setHeadTexture(int text) {
		head.setTexture(text);
	}
	
	//Gets texture for head
	public int getHeadTexture() {
		return head.getTexture();
	}
	
	//set position for head
	public void setHeadPos(Coord pos) {
		head.setPos(pos);
	}
	
	//get position for head
	public Coord getHeadPos() {
		return head.getPos();
	}
	
	//get postion of element, that was moved this time
	public Coord getBodyPos() {
		return body.getPos();
	}
	
	//get position of element, that was moved lasttime
	public Coord getPrevBodyPos() {
		return body.getPrevPos();
	}
	
	//get position of element, that was moved lasttime
	public Coord getPrevPrevBodyPos() {
		return body.getPrevPrevPos();
	}
	
	//get next position of element that will bemoved next time
	public Coord getNextBodyPos() {
		return body.getNextPos();
	}
	
	//set the texture for the body element that was moved this time
	public void setBodyTexture(int text) {
		body.setTexture(text);
	}

	//set the texture for the body element that was moved this time
	public void setPrevBodyTexture(int text) {
		body.setPrevTexture(text);
	}
	
	//Get a vector that contains all body elements
	public Vector<SnakeElement> getBodyElements() {
		return body.getSnakeElements();
	}
}