/*

	(c) Shopping-ManaJer develoment-team
	This Code is published unter the Gnu-GPL v2

*/

import javax.sound.sampled.*;
import java.io.*;
import java.util.LinkedList;

class SoundPlayer extends Thread {
	
	private class Audio {
		private AudioInputStream audioInputStream;
		private AudioFormat af;
		private byte[] audio;
		private int size;
		Clip[] clip;
		private DataLine.Info info;
		private int playNr;
		public Audio(String file) {
			playNr = 0;
			clip = new Clip[10];
			//erstellt ein Audio aus der Datei
			try{
				audioInputStream = AudioSystem.getAudioInputStream(new File(file));
				af = audioInputStream.getFormat();
				size = (int) (af.getFrameSize() * audioInputStream.getFrameLength());
				audio = new byte[size];
				info = new DataLine.Info(Clip.class, af, size);
				audioInputStream.read(audio, 0, size);
			} catch (Exception e) {
		//	e.printStackTrace();
			}
		}
		
		//Spielt das Audio ab
		public void play() {
			try {
				if (clip[playNr] != null) clip[playNr].close();
				clip[playNr] = (Clip) AudioSystem.getLine(info);
				clip[playNr].open(af, audio, 0, size);
				clip[playNr].start();
				playNr = (playNr+1)%10;
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	Audio appleSound;
	Audio turnSound;
	Audio levelDoneSound;
	Audio dieSound;
	
	private LinkedList<Audio> toPlay;
	
	boolean play;
	
	public SoundPlayer(boolean p) {
		play = p;
		try {
			appleSound = new Audio("sounds/apple.wav");
			turnSound = new Audio("sounds/turn.wav");
			levelDoneSound = new Audio("sounds/levelDone.wav");
			dieSound = new Audio("sounds/die.wav");
		} catch (Exception e) {
			System.out.println("SoundPlayer: "+e.getMessage());
			//e.printStackTrace();
		}
		toPlay = new LinkedList<Audio>();
		if (play) this.start();
	}
	
	public void run() {
		while (play) {
			playSounds();
		}
	}
	private void playSounds() {
		if (!play) return;
		waitForSounds();
		try {
			while(!toPlay.isEmpty()) {
				toPlay.poll().play();
			}
		} catch (Exception e) {
			System.out.println("SoundPlayer: "+e.getMessage());
			//e.printStackTrace();
		}
	}
	
	private synchronized void waitForSounds() {
		try {
			wait();
		} catch (Exception e) {
		}
	}
	
	public synchronized void playSound(Audio sound) {
		if (!play) return;
		toPlay.addLast(sound);
		notify();
		/*
		try {
			sound.play();
		} catch (Exception e) {
			System.out.println("SoundPlayer: "+e.getMessage());
			//e.printStackTrace();
		}
		*/
	}

}